import 'dart:async';

import 'package:fst/fst.dart';

export 'package:state_tree_interface/state_tree_interface.dart'
    show ContextStateTreeNodeTuple, ContextStateTupleApi;

void _cancelTimer(Timer timer) {
  timer.cancel();
}

extension FSTExtensions on StateTreeNode {
  void debounce<T>(Function(T arg) fn, Duration duration, T dep) {
    final timer = call((_) {
      return Timer(duration, () {
        fn(dep);
      });
    }, dep);

    dispose(_cancelTimer, timer);
  }
}
